$!-----------------------------------------------------------------------------
$! FREEWARE_DEMO.COM
$!
$! For demonstration/checking of WASD HTTP server and environment.
$!
$! UCX version ........................ @FREEWARE_DEMO
$! NETLIB version ..................... @FREEWARE_DEMO NETLIB
$! Optional SSL support (UCX) ......... @FREEWARE_DEMO SSL
$! Optional SSL support (NETLIB) ...... @FREEWARE_DEMO SSL NETLIB
$!
$! 27-JUN-98  MGD  allow calling by INSTALL.COM and UPDATE.COM
$! 20-FEB-98  MGD  add support for optional SSL
$! 23-JUL-97  MGD  add NETLIB support
$! 01-JUN-97  MGD  server uses /promiscuous to provide "authentication"
$! 10-JAN-96  MGD  initial development
$!-----------------------------------------------------------------------------
$!
$ set noon
$ verified = f$verify(0)
$ say = "write sys$output"
$!
$ if f$type(tcpipAgent) .eqs. ""
$ then
$    tcpipAgent = ""
$    if P1 .eqs. "UCX" .or. P1 .eqs. "NETLIB" then tcpipAgent = P1
$    if P2 .eqs. "UCX" .or. P2 .eqs. "NETLIB" then tcpipAgent = P2
$    if tcpipAgent .eqs. ""
$    then
$       if f$trnlnm("UCX$DEVICE","LNM$SYSTEM") .nes. "" .and. -
           f$trnlnm("NETLIB_SHR","LNM$SYSTEM") .eqs. "" -
           then tcpipAgent = "UCX"
$       if f$trnlnm("NETLIB_SHR","LNM$SYSTEM") .nes. "" .and. -
           f$trnlnm("UCX$DEVICE","LNM$SYSTEM") .eqs. "" -
           then tcpipAgent = "NETLIB"
$    endif
$ endif
$ if tcpipAgent .eqs. ""
$ then
$    tcpipAgentLoop:
$       type SYS$INPUT

--- TCP/IP AGENT? ---

|  TCP/IP agent is not obvious.
|  Choices:  UCX (Digital TCP/IP Services) or NETLIB.
$       response = ""
$       read sys$command response /prompt="[UCX]: "
$       if response .eqs. "" then response = "UCX"
$       response = f$edit(response,"UPCASE")
$       if response .nes. "UCX" .and. response .nes. "NETLIB" -
           then goto tcpipAgentLoop
$       tcpipAgent = response
$!   endTcpipAgentLoop:
$ endif
$!
$ say ""
$ say "If you have the SSL package then just add ""SSL"" to the parameters!"
$ say ""
$ say "The server is running in promiscuous mode!"
$ say "Any password/username will be accepted if required for authentication."
$ say ""
$ say "When finished evaluation abort server execution using control-Y"
$ say "(a subprocess will be spawned to preserve current privileges and process name)"
$ say ""
$!
$ on error then goto exitDemo
$ on controly then goto exitDemo
$!
$ archName = f$edit(f$getsyi("ARCH_NAME"),"UPCASE")
$ if archName .eqs. "ALPHA" then archName = "AXP"
$!
$ definedHtRoot = 0
$ if f$trnlnm("HT_ROOT","LNM$JOB") .eqs. ""
$ then
$!   (define local logicals, in line with INSTALL.COM and UPDATE.COM)
$    definedHtRoot = 1
$    currentProcedure = f$environment("PROCEDURE")
$    procDevice = f$parse(currentProcedure,,,"DEVICE","NO_CONCEAL")
$    procDirectory = f$parse(currentProcedure,,,"DIRECTORY","NO_CONCEAL")
$    htRoot = procDevice +-
        (procDirectory --
         f$extract(f$locate("HT_ROOT",procDirectory),999,procDirectory)) +-
        "HT_ROOT.]"
$    define /job /nolog /translation=concealed HT_ROOT 'htRoot'
$    htExe = "HT_ROOT:[''archName']"
$    define /job /nolog HT_EXE 'htExe'
$ else
$    htRoot = f$trnlnm("HT_ROOT","LNM$JOB")
$ endif
$!
$ exeRoot = htRoot - ".]" + ".''archName'.]"
$ scriptRoot = htRoot - ".]" + ".SCRIPT.]"
$ javaRoot = htRoot - ".]" + ".JAVA.]"
$ define /job /translation=concealed CGI-BIN 'exeRoot','scriptRoot','javaRoot'
$!
$ define /job HT_AUTH HT_ROOT:[EXAMPLE]
$ define /job HTTPD$AUTH HT_ROOT:[EXAMPLE]HTTPD$AUTH.CONF
$ define /job HTTPD$CONFIG HT_ROOT:[EXAMPLE]HTTPD$CONFIG.CONF
$ define /job HTTPD$MAP HT_ROOT:[EXAMPLE]HTTPD$MAP.CONF
$ define /job HTTPD$MSG HT_ROOT:[EXAMPLE]HTTPD$MSG.CONF
$ define /job WASD_ENABLE_SHOW 1
$!(let's base ourselves in London just for want of anywhere better!)
$ define /job HTTPD$GMT "+00:00"
$!
$ httpd = "$HT_EXE:HTTPD"
$ if P1 .eqs. "SSL" .or. P2 .eqs. "SSL"
$ then
$    httpd = httpd + "_SSL"
$    httpService = "http:7080,https:7443"
$    define /job HTTPD$SSL_CERT HT_ROOT:[EXAMPLE]HTTPD.PEM
$    say "Use a browser to access the two ""%HTTPD-I-SERVICE""s shown below ..."
$ else
$    httpService = "7080"
$    say "Use a browser to access the ""%HTTPD-I-SERVICE"" shown below ..."
$ endif
$ say ""
$ if tcpipAgent .eqs. "NETLIB" then httpd = httpd + "_NETLIB"
$!(the ";0" ensures the latest version, not any prior INSTALLed version)
$ httpd = httpd + ".EXE;0"
$!
$ spawn /wait httpd /nolog /nomonitor /promiscuous /service='httpService'
$!
$ exitDemo:
$!
$ if definedHtRoot
$ then
$    deassign /job HT_ROOT
$    deassign /job HT_EXE
$ endif
$ deassign /job HT_AUTH
$ deassign /job CGI-BIN
$ deassign /job HTTPD$AUTH
$ deassign /job HTTPD$CONFIG
$ deassign /job HTTPD$MAP
$ deassign /job HTTPD$MSG
$ deassign /job WASD_ENABLE_SHOW
$ deassign /job HTTPD$GMT
$ if f$trnlnm("HTTPD$SSL_CERT","LNM$JOB") .nes. "" -
     then deassign /job HTTPD$SSL_CERT
$!
$ say ""
$ if .not. verified then set noverify
$!
$!-----------------------------------------------------------------------------
