/*****************************************************************************/
/*
                                  MapUrl.h
*/
/*****************************************************************************/

#ifndef MAPURL_H_LOADED
#define MAPURL_H_LOADED 1

#include "wasd.h"

#define MAPURL_REPORT_MATCH_NOT         0
#define MAPURL_REPORT_MATCH_RULE        1
#define MAPURL_REPORT_MATCH_RULECOND    2
#define MAPURL_REPORT_MATCH_RULENOCOND  3
#define MAPURL_REPORT_MATCH_VIRT        4

/*******************/
/* data structures */
/*******************/

#ifdef __ALPHA
#   pragma member_alignment __save
#   pragma member_alignment
#endif

/* rule database is a singly-linked list of these structures */
struct MappingRuleStruct
{
   struct MappingRuleStruct  *NextPtr;

   boolean  IsCgiPlusScript,
            SetPathCache,
            SetPathNoCache,
            SetPathExpired,
            SetPathNoExpired,
            SetPathLog,
            SetPathNoLog,
            SetPathStmLF,
            SetPathNoStmLF;

   int  MapFileLineNumber,
        SetPathCharsetLength,
        SetPathContentTypeLength,
        SetPathIndexLength;

   unsigned long  VirtualServerHostNameHashValue;

   char  RuleType,
         SetPathRmsSubChar;

   char  *ConditionalPtr,
         *ResultPtr,
         *SetPathCharsetPtr,
         *SetPathContentTypePtr,
         *SetPathIndexPtr,
         *TemplatePtr,
         *VirtualServerHostPortPtr;

   struct MappingRuleStruct  *NextVirtualServiceRulePtr;
   /* strings are stored straight after and pointed to by the above */
};

struct MappingRuleListStruct
{
   struct MappingRuleStruct  *HeadPtr;
   struct MappingRuleStruct  *TailPtr;

   int  LineNumber,
        ProblemCount,
        ProblemReportLength;

   unsigned long  LoadBinTime [2],
                  RevBinTime [2];

   char  *LinePtr,
         *ProblemReportPtr;

   char  LoadFileName [256],
         RuleName [32];

   struct RequestStruct  *RequestPtr;
};

#ifdef __ALPHA
#   pragma member_alignment __restore
#endif

/***********************/
/* function prototypes */
/***********************/

/* "quick and dirty" return path equivalent of VMS file specification */
#define MapVmsPath(vp,rp) MapUrl_Map(NULL,vp,NULL,NULL,rp)

char* MapUrl_Map (char*, char*, char*, char*, struct RequestStruct*);
char* MapUrl__Map (char*, char*, char*, char*, struct RequestStruct*);
char* MapUrl_LoadRules (struct MappingRuleListStruct*);
char* MapUrl_ReportProblem (struct MappingRuleListStruct*, char*, int);
int MapUrl_UrlToVms (char*, char*, char);
int MapUrl_VmsToUrl (char*, char*, boolean);
int MapUrl_VirtualPath (char*, char*, char*, int);

#endif /* MAPURL_H_LOADED */

/*****************************************************************************/
